#!/usr/bin/env python3

"""
A program that sorts a list DESCENDINGLY by the REVERSE VALUE of its
elements without using Python's built-in functions for sorting them.

This program is actually a copy of `exercise-04-03.py` with the
needed modifications done in the `my_sort` function.
"""

def load_a_list_of_ints():
    """
    Loads a list of integers by first asking for its length.
    """
    L = list()
    n = int(input("The number of list elements: "))
    for k in range(n):
        L.append(int(input(str(k+1) + ". element: ")))
    return L

# The following function is from `exercise-03-05.py`
def rev(n):
    """
    Returns the number that is obtained from the integer `n` by
    reversing the order of the digits.
    """

    res = 0

    if n < 0:
        n = -n
        sign = -1
    else:
        sign = 1

    while n > 0:
        res = 10 * res + n%10
        n //= 10

    return sign * res

def my_sort(L):
    """
    Sorts the list `L`.
    """
    n = len(L)
    for left in range(n-1):
        right = left  # assume that this one is the minimum; check all the others
        for k in range(left+1, n):
            # The changes are all in the following `if`. These are:
            # 1. Since we want to sort in a descending order, we look for
            #    the biggest element to put it to the front.
            #    Hence, we replace '<' with '>'.
            #    (yes, this is the only change regarding the direction of sort)
            # 2. We also don't compare the values of the numbers, but instead
            #    we compare their reversed values.
            #    For this, we wrap `L[k]` and `L[right]` in `rev(...)`.
            if rev(L[k]) > rev(L[right]):
                right = k
        # The only changes that are needed are above!
        # This part remains the same:
        if right > left:
            tmp = L[left]
            L[left] = L[right]
            L[right] = tmp

def main():
	x = load_a_list_of_ints()
	print("Before sorting:", x)
	my_sort(x)
	print("After sorting: ", x)

main()