#!/usr/bin/env python3

"""
A program that loads a sorted (this is not checked!) list of integers and
an additional integers, and checks if that one is a member of the list,
using the binary search algorithm.

If there is more than one such element, the index of the last one is returned.
"""

def load_a_list_of_ints():
    """
    Loads a list of integers by first asking for its length.
    """
    L = list()
    n = int(input("The number of list elements: "))
    print("Please input your numbers in the sorted order.")
    for k in range(n):
        L.append(int(input(str(k+1) + ". element: ")))
    return L

def search(L, el):
    """
    Returns the index of `el` in `L` if it exists, or `None` otherwise.
    """
    left = 0
    right = len(x)-1

    while right >= left:
        mid = (left + right) // 2
        if L[mid] == el:
            # We have found ONE such element.
            # If there is more than one, it might be ANY of them.
            # To find the last one, we need to increase `mid`
            # as long as we have the same value. We also need to be careful
            # not to go beyond the end of the list.
            last_idx = len(L) - 1
            while mid < last_idx and L[mid+1] == el:
                mid += 1
            return mid
        if L[mid] < el:
            left = mid + 1
        else:
            right = mid - 1
    return None

def main():
	#x = [11, 13, 17, 19, 23, 29, 31, 37, 41, 43]
	x = load_a_list_of_ints() # comment out for faster testing
	el = int(input("Which number are you interested in? "))

	idx = search(x, el)
	if idx is None:
		print("The number " + str(el) + " does not exist in the list.")
	else:
		print("Index of " + str(el) + " in the list:", idx)

main()