#!/usr/bin/env python3

"""
A program that loads a list of integers sorted DESCENDINGLY by the REVERSE
VALUE of its elements (this is not checked!) and an additional integer, and
checks if that one is a member of the list, using the binary search algorithm.
"""

def load_a_list_of_ints():
    """
    Loads a list of integers by first asking for its length.
    """
    L = list()
    n = int(input("The number of list elements: "))
    print("Please input your numbers in the sorted order.")
    for k in range(n):
        L.append(int(input(str(k+1) + ". element: ")))
    return L

# The following function is from `exercise-03-05.py`
def rev(n):
    """
    Returns the number that is obtained from the integer `n` by
    reversing the order of the digits.
    """

    res = 0

    if n < 0:
        n = -n
        sign = -1
    else:
        sign = 1

    while n > 0:
        res = 10 * res + n%10
        n //= 10

    return sign * res

def search(L, el):
    """
    Returns the index of `el` in `L` if it exists, or `None` otherwise.
    """
    left = 0
    right = len(x)-1
    rev_el = rev(el)  # this is the value that we're actually searching for
                      # among rev(L[0]), rev(L[1]),...

    while right >= left:
        mid = (left + right) // 2
        rev_mid = rev(L[mid])
        if rev_mid == rev_el:
            return mid
        # Since the ordering in the list is now descending,
        # we have to take that into account, which is easiest
        # done by replacing '<' with '>'.
        if rev_mid > rev_el:
            left = mid + 1
        else:
            right = mid - 1
    return None

def main():
	#x = [1719, 1123, 3113]
	x = load_a_list_of_ints() # comment out for faster testing
	el = int(input("Which number are you interested in? "))

	idx = search(x, el)
	if idx is None:
		print("The number " + str(el) + " does not exist in the list.")
	else:
		print("Index of " + str(el) + " in the list:", idx)

main()