#!/usr/bin/env python3

"""
A program that load a list and checks if it is sorted ascendingly.
"""

def load_a_list_of_ints():
    """
    Loads a list of integers by first asking for its length.
    """
    L = list()
    n = int(input("The number of list elements: "))
    for k in range(n):
        L.append(int(input(str(k+1) + ". element: ")))
    return L

def is_sorted_asc(L):
    """
    Returns `True` if the list `L` is sorted ascendingly, and `False` otherwise.
    """
    # Compare all n-1 neighbour pairs of elements
    for k in range(1, len(L)):
        if L[k-1] > L[k]:
            # (k-1)-st and k-th are in the wrong order, so the list is
            # not sorted (at least not ascendingly by the elements' value).
            return False
    # We found no counter-examples among neighbour elements, so we
    # conclude that the list is sorted as requested.
    # Notice that this works properly on empty and single-element lists as well.
    return True

def main():
	x = load_a_list_of_ints()
	if is_sorted_asc(x):
		print("The list is sorted ascendingly by the value of its elements.")
	else:
		print("The list is NOT sorted ascendingly by the value of its elements.")

main()